using namespace Graph_lib;
class Turtle {
	static const int TURTLE_BODY_SIZE = 20; // pixels
	static const int TURTLE_HEAD_SIZE = TURTLE_BODY_SIZE/2; // pixels
	static const int TURTLE_ANIMATION_PIXELS = 1;
	Circle m_cir_body;
	Circle m_cir_head;
	int m_distance;
public:
	Turtle( Simple_window& wnd, Point origin )
		:
	m_cir_body( origin, TURTLE_BODY_SIZE ),
	// construct "easterly" head
	m_cir_head(
		Point ( origin.x + TURTLE_HEAD_SIZE, origin.y ),
		TURTLE_HEAD_SIZE
		),
	m_distance( 0 )
	{
		wnd.attach( m_cir_body );
		m_cir_head.set_fill_color( Color::dark_green );
		wnd.attach( m_cir_head );
	}

	void go( int distance )
	{
		m_distance = distance;
		go();
	}
	void go()
	{
		Fl::add_timeout( ANIMATION_TIMEOUT, callback_animate, this );
	}
	void animate()
	{
		if ( m_distance == 0 )
		{
			return;
		}
		m_cir_body.move( TURTLE_ANIMATION_PIXELS, 0 );
		m_cir_head.move( TURTLE_ANIMATION_PIXELS, 0 );
		Fl::redraw();
		--m_distance;
		Fl::repeat_timeout( ANIMATION_TIMEOUT, callback_animate, this );
	}

	static void callback_animate( void* pthing )
	{
		//Turtle* xyz = pthing;
		Turtle* self = static_cast< Turtle* >( pthing );
		self->animate();
	}

};//class Turtle